﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using System.ComponentModel;
using HealthyHitsujiWpf.Model;
using HealthyHitsujiWpf.Model.Content;

namespace HealthyHitsujiWpf.Command
{
    public class _APropertyChangedCommand : ICommand
    {

        protected _ACommandBindableModel commandBindableModel
        { 
            get; 
            set; 
        }


        #region ▼イベント（処理）の初期設定

        protected void initEventTemplate()
        {
            commandBindableModel.PropertyChanged += eventTemplate;
        }
        protected void initMethodTemplate()
        {
            commandBindableModel.PropertyChanged += methodTemplate;
        }

        #endregion ▲イベント（処理）の初期設定


        #region ▼イベント（処理）の設定登録・解除

        public void addEventTemplate()
        {
            commandBindableModel.PropertyChanged += eventTemplate;
        }
        public void removeEventTemplate()
        {
            commandBindableModel.PropertyChanged -= eventTemplate;
        }

        #endregion ▲イベント（処理）の設定登録・解除


        #region ▼イベント（処理）のテンプレート
        
        private void methodTemplate(object sender, PropertyChangedEventArgs e)
        {
            if (CanExecute(null))
                Execute(null);
        }

        private void eventTemplate(object sender, PropertyChangedEventArgs e)
        {
            if (CanExecuteChanged != null)
                CanExecuteChanged(this, EventArgs.Empty);
        }

        #endregion ▲イベント（処理）のテンプレート


        #region ICommand メンバ

        public bool CanExecute(object parameter)
        {
            if (commandBindableModel.canExeDelegate_ != null)
            {
                return commandBindableModel.canExeDelegate_();
            }
            else
            {
                return false;
            }
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            if (commandBindableModel.exeDelegate_ != null)
            {
                commandBindableModel.exeDelegate_();
            }
            else
            {
                return;
            }
        }

        #endregion

    }
}
