﻿using System;
using System.Collections.Generic;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.ObserverPattern.Subject;
using HitsujiLibrary201004.ObserverPattern.Observer;
using HitsujiLibrary201004.ObserverPattern.Subject;
using HealthyHitsujiWpf.Model.View;

namespace HealthyHitsujiWpf.ObserverPattern.Observer
{
    public class ReflectUiMonthDataListBoxObserver : _IObserver, _IReflectUiObserver
    {

        #region _IObserver メンバ

        public void doMyRole(_ASubject subj)
        {
            try
            {
                GetSelectedMonthDataSubject subject = (subj as GetSelectedMonthDataSubject);
                MonthContentsModel monthData = subject.models["MonthContentsModel"] as MonthContentsModel;

                List<Action> dispatchActionList = new List<Action>();
                dispatchActionList.Add(delegate()
                {
                    monthDataViewModel_.listBoxItemsSource = monthData;
                });

                //処理実行
                reflectUi(dispatchActionList);

            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
        }

        #endregion


        #region _IReflectUiObserver メンバ

        private MonthDataListBoxViewModel monthDataViewModel_;
        public void setRefViewModel(_AViewModel vm)
        {
            monthDataViewModel_ = (vm as MonthDataListBoxViewModel);
        }

        public void reflectUi(List<Action> dispatchActionList)
        {
            try
            {
                foreach (Action act in dispatchActionList)
                {
                    monthDataViewModel_.BaseUiWindow.Dispatcher.Invoke(act);
                }
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex;
            }
        }

        #endregion

    }
}
