﻿using System;
using System.IO;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.DataBase;
using HitsujiLibrary201004.Utils.Date;
using HitsujiLibrary201004.Utils.Data;

namespace HealthyHitsujiWpf.ObserverPattern.Subject
{
   public class GetSelectedMonthDataSubject : _AHitsujiSubject
   {

       public override void doMyRole()
       {
           try
           {
               base.models.Add("MonthContentsModel", new MonthContentsModel());

               var selectedDateInfo = (SelectedDateModel)models["SelectedDateModel"];

               var year = selectedDateInfo.SelectedDate.Year;
               var month = selectedDateInfo.SelectedDate.Month;
               var day = selectedDateInfo.SelectedDate.Day;
               var dateCountOfMonth = HDateCountUtil.getDateCount(year, month);

               //ディレクトリの存在確認（ない場合は作成）
               if (!Directory.Exists(MonthDataBaseFile.getDirectoryPath_AsMonthData().ToString()))
               {
                   Directory.CreateDirectory(MonthDataBaseFile.getDirectoryPath_AsMonthData().ToString());
                   System.Threading.Thread.Sleep(200);
               }

               //データベースのファイルパス
               var filePathBuilder = MonthDataBaseFile.buildDataBaseFilePath(year, month);

               //データファイルの存在確認
               if (!File.Exists(filePathBuilder.ToString()))
               {
                   //データ読み込み（データファイルが存在しない場合）
                   (models["MonthContentsModel"] as MonthContentsModel).getDefaultMonthData(selectedDateInfo.SelectedDate.Year,
                                                                                            selectedDateInfo.SelectedDate.Month,
                                                                                            selectedDateInfo.SelectedDate.Day);
               }
               else
               {
                   //データ読み込み（データファイルが存在する場合）
                   (models["MonthContentsModel"] as MonthContentsModel).getMonthData(filePathBuilder,
                                                                                        selectedDateInfo.SelectedDate.Year,
                                                                                        selectedDateInfo.SelectedDate.Month,
                                                                                        selectedDateInfo.SelectedDate.Day);
               }
               
               base.notify(this);
           }
           catch (Exception ex)
           {
               throw ex;
           }
       }
    }
}
