﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Threading;

namespace HitsujiClockLibrary.HitsujiClock.TOYO_ON.Clock
{
    /// <summary>
    /// HDegitalClock_K_ON_01.xaml の相互作用ロジック
    /// </summary>
    public partial class HDegitalClock_K_ON_01 : UserControl
    {
        public HDegitalClock_K_ON_01()
        {
            InitializeComponent();

        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            initImageSource();

            Thread thread = new System.Threading.Thread(new System.Threading.ThreadStart(runTime));
            thread.IsBackground = true;
            thread.Name = "Thread-Clock";
            thread.Start();
                
        }

        protected void initImageSource()
        {
            String imageFile = new StringBuilder("./../Image/" + new Random().Next(1, 8).ToString("00") + ".JPG").ToString();
            DataContext = imageFile;
        }

        protected void runTime()
        {
            bool separatorDisplay = true;
            while (true)
            {
                var nowTime = DateTime.Now;
                
                //更新処理内容
                Action act = delegate()
                {
                    this.label1.Content = new StringBuilder(" ")
                                                    .Append(nowTime.Month.ToString("00"))
                                                    .Append("/")
                                                    .Append(nowTime.Day.ToString("00"))
                                                    .Append("  ")
                                                    .Append(nowTime.Hour.ToString("00"))
                                                    .Append(" : ")
                                                    .Append(nowTime.Minute.ToString("00"))
                                                    .Append(getSeparator(ref separatorDisplay)).ToString();
                };

                //更新処理実行
                this.Dispatcher.Invoke(act);
                Thread.Sleep(500);
            }
        }

        protected String getSeparator(ref bool separatorDisplay)
        {
            if (separatorDisplay) 
            {
                separatorDisplay = false;
                return " ♪";
            }
            else 
            {
                separatorDisplay = true;
                return "  ♪";
            }
        }
    }
}
