﻿using System;
using System.Collections.Generic;
using HitsujiLibrary201004.ObserverPattern.Observer;

namespace HitsujiLibrary201004.ObserverPattern.Subject
{
    public abstract class _ASubject// : _ISubject
    {

        private Dictionary<String, _IObserver> observerDictionary;
        
        
        public _IObserver getObserver(string observerClassName)
        {
            if (observerDictionary.Count <= 0){ throw new NullReferenceException();}
            _IObserver observer = null;
            foreach (KeyValuePair<String, _IObserver> kvp in observerDictionary)
            {
                observer = kvp.Value;
            }

            if (observer == null) { throw new NullReferenceException(); }
            return observer;
        }


        public void addObserver(_IObserver observer)
        {
            try
            {
                if (observerDictionary == null) { observerDictionary = new Dictionary<string, _IObserver>(); }
                this.observerDictionary.Add(observer.GetType().Name, observer);
            }
            catch(Exception ex)
            {
                Console.Write(ex.ToString());
                throw ex; 
            }
        }


        public void removeObserver(_IObserver observer)
        {
            this.observerDictionary.Remove(observer.GetType().Name);
        }


        public void notify(_ASubject subject)
        {
            if (observerDictionary.Count <= 0) { return; }
            foreach (KeyValuePair<String, _IObserver> kvp in observerDictionary)
            {
                kvp.Value.doMyRole(this);
            }
        }


        public abstract void doMyRole();
        
    }
}
